Subject: Re: bonding (IEEE 802.3ad) not working with qemu/virtio

From: "Michael S. Tsirkin" <[email-masked]>
Date: Sun, 31 Jan 2016 16:35:35 +0200

On Fri, Jan 29, 2016 at 01:45:00PM -0800, Jay Vosburgh wrote:
> Nikolay Aleksandrov <[email-masked]> wrote:
> 
> >On 01/25/2016 05:24 PM, Bjørnar Ness wrote:
> >> As subject says, 802.3ad bonding is not working with virtio network model.
> >> 
> >> The only errors I see is:
> >> 
> >> No 802.3ad response from the link partner for any adapters in the bond.
> >> 
> >> Dumping the network traffic shows that no LACP packets are sent from the
> >> host running with virtio driver, changing to for example e1000 solves
> >> this problem
> >> with no configuration changes.
> >> 
> >> Is this a known problem?
> >> 
> >[Including bonding maintainers for comments]
> >
> >Hi,
> >Here's a workaround patch for virtio_net devices that "cheats" the
> >duplex test (which is the actual problem). I've tested this locally
> >and it works for me.
> >I'd let the others comment on the implementation, there're other signs
> >that can be used to distinguish a virtio_net device so I'm open to suggestions.
> >Also feedback if this is at all acceptable would be appreciated.
> 
> 	Should virtio instead provide an arbitrary speed and full duplex
> to ethtool, as veth does?
> 
> 	Creating a magic whitelist of devices deep inside the 802.3ad
> implementation seems less desirable.
> 
> 	-J

Absolutely but why not tream DUPLEX_UNKNOWN as DUPLEX_FULL
and allow LACP?

> ---
> 	-Jay Vosburgh, [email-masked]